chiark / gitweb /
xinitrc: Don't clobber xbound in start-xterms.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
8ba15f37 13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
852cd5fb 116echo " all done."
f617db13 117
ce178f96
MW
118###--------------------------------------------------------------------------
119### Install global configuration.
120
f141fe0f
MW
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
ce178f96 129## Symlink the various dotfiles into place
852cd5fb 130dotfiles="
be7dba95 131 bash_profile bash_logout bashrc inputrc bash_completion
b3468c3b 132 emacs emacs-calc vm
3e3c03ee 133 vimrc mg
b3468c3b 134 mailrc signature
ce178f96 135 cgrc tigrc
e7d23024 136 gdbinit
8a7e906d 137 guile
5d25e440 138 toprc
cbffcf2b 139 aspell.conf
ccaac00b
MW
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
f6335a0c 143 lisp-init.lisp:.eclrc
2425eca9 144 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 145[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 146 xinitrc xsession Xdefaults vncrc vncsession
1c6b19d4 147 putty-defaults:.putty/sessions/Default%20Settings
7cfa1f1a 148 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 149 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 150 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
eebca092
MW
151 e16-bindings:.e16/bindings.cfg
152 e16-config:.e16/e_config--1.0.cfg
153 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
154 jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
f617db13
MW
155echo "Installing dotfiles..."
156for d in $dotfiles; do
739bccbf
MW
157 target=.$d
158 case $d in
159 *:*) target=${d#*:} d=${d%%:*};;
160 esac
161 ft=$HOME$sub/$target
162 dir=${ft%/*}
163 mkdir -p $dir
164 ln -s $here/$d $ft.new
165 mv $ft.new $ft
166 echo " $target"
f617db13 167done
852cd5fb 168echo " all done."
f617db13 169
ce178f96
MW
170###--------------------------------------------------------------------------
171### Process the Git configuration.
172
173echo -n "Installing Git configuration:"
174sed "
1751i\
15581433 176### generated by $here/setup; do not edit!\
ce178f96
MW
177
178/@releasekey@/ s::$(./mdw-conf release-key 481334C2):g
15581433 179/@gitignore@/ s::$(./mdw-conf gitignore $here/gitignore):g
ce178f96
MW
180" gitconfig >$HOME/.gitconfig.new
181mv $HOME/.gitconfig.new $HOME/.gitconfig
182echo " done."
183
184###--------------------------------------------------------------------------
185### Install useful scripts included in this package.
186
e04c4857 187scripts="
547fb8af 188 mdw-editor
b056f5c4 189 mdw-conf
8e08f814 190 movemail-hack
285a1386
MW
191 emerge-hack
192 lesspipe.sh
193 start-ssh-agent
4cdeb0d0
MW
194 svnwrap
195 hyperspec"
8e08f814
MW
196[ "$xstuff" ] && scripts="$scripts
197 xrun
198 xshutdown"
e04c4857
MW
199echo "Installing scripts..."
200mkdir -p $HOME$sub/bin
201for s in $scripts; do
202 ft=$HOME$sub/bin/$s
203 ln -s $here/$s $ft.new
204 mv $ft.new $ft
205 echo " $s"
206done
207echo " all done."
208
ce178f96
MW
209###--------------------------------------------------------------------------
210### Set up the Emacs config.
211
65ff0e8c
MW
212$echon "Finding a suitable emacs:$echoc"
213emacs=no
6960aa99 214for i in emacs22 emacs21 emacs; do
65ff0e8c
MW
215 if type -p >/dev/null $i; then
216 emacs=$i
217 break
218 fi
219done
220if [ $emacs = no ]; then
221 echo " failed."
222 emacs=:
223else
224 echo " $emacs."
225fi
226
f617db13 227echo "Installing Emacs packages..."
400223a1
MW
228emacspkg="
229 make-regexp
a1293ade 230 ew-hols
1778b496 231 git git-blame vc-git stgit
400223a1
MW
232 quilt"
233for elib in $emacspkg; do
f617db13 234 $echon " $elib:$echoc"
65ff0e8c 235 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 236 (progn
852cd5fb
MW
237 (setq load-path (nconc load-path (list "~/lib/emacs")))
238 (kill-emacs (condition-case nil
239 (progn (load-library "'"$elib"'") 0)
20eb0692 240 (error 1))))'; then
f617db13
MW
241 echo " already installed."
242 else
243 $echon " downloading$echoc"
20eb0692 244 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
f617db13
MW
245 $echon " compiling$echoc"
246 (cd $HOME$sub/lib/emacs;
65ff0e8c 247 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 248 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
249 echo " done."
250 fi
251done
852cd5fb 252echo " all done."
f617db13
MW
253
254$echon "Setting up Emacs configuration:$echoc"
255$echon " linking$echoc"
256for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
257 set -- $(echo $link | tr : ' ')
258 from=$1 to=$2
739bccbf
MW
259 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
260 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
f617db13
MW
261done
262$echon " compiling$echoc"
65ff0e8c 263make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 264echo " done."
ce178f96
MW
265
266###----- That's all, folks --------------------------------------------------